<?php
/**
 * IMAP ACL Manipulation Plugin
 *
 * Copyright (c) 2003 Samuel Graenacher
 *
 * Licensed under the GNU GPL. For full terms see the file COPYING that came
 * with the Squirrelmail distribution.
 *
 * Written by Samuel Graenacher.
 * Developped for SM version 1.4.1
 *
 * For more licensing (and other) information, see the header of "imapacl.php"
 * $Id$
 */

if (!defined("SM_PATH"))
    define('SM_PATH','../../');

include_once(SM_PATH . 'include/validate.php');
include_once(SM_PATH . 'include/load_prefs.php');
include_once(SM_PATH . 'functions/page_header.php');
include_once(SM_PATH . 'functions/imap.php');

// We load up all the imapacl functions.
include_once(SM_PATH . 'plugins/imapacl/imapacl.php');
include_once(SM_PATH . 'plugins/imapacl/label_table.php');

IA_init_language();

sqsession_is_active();

// First, we'll need to fetch a few params we've gotten by either methods
global $folder2edit;
sqgetGlobalVar('folder2edit', $folder2edit, SQ_FORM);
global $user2edit;
sqgetGlobalVar('user2edit', $user2edit, SQ_FORM);

// Check for necessary parameters..
if ((strlen($folder2edit) < 1)||(strlen($user2edit) < 1)) {
    $errormsg = _("Missing data.<p />You have accessed this page in a way it wasn't meant to be!");
    print $errormsg;
    print_errormsg($errormsg);
}

// Fetch the rest of the params... like the Other Options...
global $OOCB_REC;
sqgetGlobalVar('OOCB_REC', $OOCB_REC, SQ_FORM);


// Let's find out if we need to display a confirm dialog...
global $ia_confirm;
sqgetGlobalVar('ia_confirm', $ia_confirm, SQ_FORM);
global $ia_confirm_yes;
sqgetGlobalVar('ia_confirm_yes', $ia_confirm_yes, SQ_FORM);
global $ia_confirm_no;
sqgetGlobalVar('ia_confirm_no', $ia_confirm_no, SQ_FORM);



// Did we already display the confirm. dialog and the user pressed "no"?
// If so, we can speed up things and redirect the user back.
if (strlen($ia_confirm_no) >= 1)
{
    // Send header to go back to folder management screen.
    $relativeredir = "foldermanage.php?ia_folder2manage=$folder2edit";
    header('Location: http://'.$_SERVER['HTTP_HOST']
                      .dirname($_SERVER['PHP_SELF'])
                      .'/'.$relativeredir);
    exit;
}

// Determine if we're supposed to delete... we default to editmode.
$action = _("edit");

// check if someone pressed the "delete user" button
global $deleteuser;
sqgetGlobalVar('deleteuser', $deleteuser, SQ_FORM);
if (strlen($deleteuser) >= 1)
    $action = _("delete");


if ($action == _("delete")) { // If we already know we're gonna delete, this is unnecessary..
    $looked_at = 0;
    $disabled = 0;

    reset($rightsList);
    while (list($rn, $discard) = each($rightsList)) {
        $vname = 'IACB_'.strtoupper($rn);
        global ${$vname};
        sqgetGlobalVar($vname, ${$vname}, SQ_FORM);
        $looked_at += 1;
        if (strlen(${$vname}) < 1)
            $disabled += 1;
        unset(${$vname});
    }
    if ($looked_at == $disabled)
        $action = _("delete");
}

// Start the HTML body output!
displaySMPageHeader($color, 'None');

// Sanity check...
if ($ia_cfg_doSanity == 1 && $user2edit == $username) {
    $san  = _("Sorry, but you cannot edit your own rights.") . "\n<P /><P />\n";
    $san .= "<A HREF=\"foldermanage.php?ia_folder2manage=$folder2edit\">". _("Back to Foldermanagement") ."</A>\n";
    $sanbox = ia_html_box(_("Sanity Check"), $san);

    ia_html_mainbox(_("IMAP ACL Management"), $sanbox);
    exit;
}



// Apparently, the confirmation dialog hasn't been displayed yet. Let's do so.
if ($ia_confirm != "displayed") {
    $confirmdlg  = "<FORM METHOD=POST ACTION=\"".$_SERVER["PHP_SELF"]."\">\n";
    $confirmdlg .= "<INPUT TYPE=\"hidden\" NAME=\"ia_confirm\" VALUE=\"displayed\">\n";
    // Now we populate the form with all the hidden data we will need to know.
    $confirmdlg .= "<INPUT TYPE=\"hidden\" NAME=\"folder2edit\" VALUE=\"$folder2edit\">\n";
    $confirmdlg .= "<INPUT TYPE=\"hidden\" NAME=\"user2edit\" VALUE=\"$user2edit\">\n";
    if (isset($deleteuser) && (strlen($deleteuser) >= 1)) {
        $confirmdlg .= "<INPUT TYPE=\"hidden\" NAME=\"deleteuser\" VALUE=\"yes\">\n";
    } else {
        reset($rightsList);
        while (list($rn, $discard) = each($rightsList)) {
            $vname = 'IACB_'.strtoupper($rn);
            global ${$vname};
            sqgetGlobalVar($vname, ${$vname}, SQ_FORM);
            if (strlen(${$vname}) < 1)
                $confirmdlg .= "<INPUT TYPE=\"hidden\" NAME=\"$vname\" VALUE=\"checked\">\n";
            unset(${$vname});
        }
    }
    $confirmdlg .= "<INPUT TYPE=\"hidden\" NAME=\"OOCB_REC\" VALUE=\"$OOCB_REC\">\n";
    
    if (empty($OOCB_REC)) {
        $confirmdlg .= sprintf(_("Are you sure you want to %s the user %s in folder %s?"), 
                                $action, $user2edit, $folder2edit);
    } else {
        $confirmdlg .= sprintf(_("Are you sure you want to %s the user %s in folder %s and all its subfolders?"), 
                                $action, $user2edit, $folder2edit);
    }
    $confirmdlg .= "\n<P /><P />\n<CENTER><INPUT TYPE=\"submit\" NAME=\"ia_confirm_yes\" VALUE=\"".
                    _("Yes")."\">&nbsp;&nbsp;<INPUT TYPE=\"submit\" NAME=\"ia_confirm_no\" VALUE=\"".
                    _("No")."\"></CENTER>\n";
    $confirmdlg .= "</FORM>\n";

    $cbox = ia_html_box(_("Confirm"), $confirmdlg);
    ia_html_mainbox(_("IMAP ACL Management"), $cbox);

    exit;
}

// Ok, now the fun begins! The user just confirmed an action to be done.
if (strlen($ia_confirm_yes) >= 1 ) {

    // First we need an imap connection...
    global $imapServerAddress, $imapPort;
    sqgetGlobalVar('key', $key, SQ_COOKIE);
    sqgetGlobalVar('onetimepad', $onetimepad, SQ_SESSION);
    $conn = $imapConnection = sqimap_login($username, $key, $imapServerAddress, $imapPort, 0);

    $actionbox = _("Internal Error. Unknown Action!"); // This shouldn't ever be seen.

    if ($action == _("delete")) {
        // Deleting is simple.

        unset($foldersToProcess);
        if (empty($OOCB_REC)) {
            $foldersToProcess[] = $folder2edit;
        } else {
            // Enumerate subdirs
            $foldersToProcess = findSubdirs($imapConnection, $folder2edit);
        }
        foreach($foldersToProcess as $curfol) {
            delACL($conn, $curfol, $user2edit);
        }
        // FIXME: Implement error handling.
        $desc  = "<CENTER>"._("Successfully deleted user.")."</CENTER>\n<P />\n";
        $desc .= "<A HREF=\"foldermanage.php?ia_folder2manage=$folder2edit\">". _("Back to Foldermanagement") ."</A>\n";
        $actionbox = ia_html_box(_("Status"), $desc);
    } else {
        // Editing takes a tad more work:
        //  First, we need to construct the permission flag string:
        $pflags = "";
        reset($rightsList);
        while (list($rn, $discard) = each($rightsList)) {
            $vname = 'IACB_'.strtoupper($rn);
            global ${$vname};
            sqgetGlobalVar($vname, ${$vname}, SQ_FORM);
            if (strlen(${$vname}) < 1)
                $pflags .= strtolower($rn);
            unset(${$vname});
        }

        unset($foldersToProcess);
        if (empty($OOCB_REC)) {
            $foldersToProcess[] = $folder2edit;
        } else {
            // Enumerate subdirs
            $foldersToProcess = findSubdirs($imapConnection, $folder2edit);
        }
        //  And now, we edit the user on the server:
        $desc  = "<CENTER>"._("Edited user permissions on folder(s):")."</CENTER><BR />\n";
        foreach($foldersToProcess as $curfol) {
            setACL($conn, $curfol, $user2edit, $pflags);
            $desc .="<CENTER>".$curfol."</CENTER><BR />\n";
        }
        // FIXME: Implement error handling.
        $desc .= "<A HREF=\"foldermanage.php?ia_folder2manage=$folder2edit\">". _("Back to Foldermanagement") ."</A>\n";
        $actionbox = ia_html_box(_("Status"), $desc);
    }

    ia_html_mainbox(_("IMAP ACL Management"), $actionbox);
    exit;
}

IA_clean_language();


?>