<?php
/**
 * IMAP ACL Manipulation Plugin
 *
 * Copyright (c) 2003 Samuel Graenacher
 *
 * Licensed under the GNU GPL. For full terms see the file COPYING that came
 * with the Squirrelmail distribution.
 *
 * Written by Samuel Graenacher.
 * Developped for SM version 1.4.1
 *
 * For more licensing (and other) information, see the header of "imapacl.php"
 * $Id$
 */

if (!defined("SM_PATH"))
    define('SM_PATH','../../');
/*
include_once(SM_PATH . 'functions/i18n.php');
include_once(SM_PATH . 'include/validate.php');
include_once(SM_PATH . 'include/load_prefs.php');
include_once(SM_PATH . 'functions/page_header.php');
include_once(SM_PATH . 'functions/imap.php');
*/
// We load up all the imapacl functions.
include_once(SM_PATH . 'plugins/imapacl/imapacl.php');
include_once(SM_PATH . 'plugins/imapacl/label_table.php');

IA_init_language();

sqsession_is_active();

// Initiating the imap connection.
global $imapServerAddress, $imapPort;
global $color;

sqgetGlobalVar('key', $key, SQ_COOKIE);
sqgetGlobalVar('onetimepad', $onetimepad, SQ_SESSION);
$imapconn = $imapConnection = sqimap_login($username, $key, $imapServerAddress, $imapPort, 0);

//print "Initiating GETACL...\n";

global $ia_folder2manage;
sqgetGlobalVar('ia_folder2manage', $ia_folder2manage, SQ_FORM);


// Now we start constructing the page...
displaySMPageHeader($color, 'None');


$parsed = getACL($imapconn, $ia_folder2manage);

// We load the row template.
$trtpl = new EasyTemplate(SM_PATH . 'plugins/imapacl/templates/foldermanage_tablerow.html');

$color_iterator = 1;

$tablerows = "";

while (list($permuser, $permdata) = each($parsed))
{
    $trtpl->clear_assign();

    labeltable_apply($trtpl, 'foldermanage_tablerow');

    $trtpl->assign("USERNAME", $permuser);
    $trtpl->assign("USERNAME_URLENC", urlencode($permuser));
    $trtpl->assign("FOLDER", $ia_folder2manage);
    $trtpl->assign("FOLDER_URLENC", urlencode($ia_folder2manage));

    if ($color_iterator % 2 == 0) 
        $current_color = $color[4];
    else
        $current_color = $color[12];
    $trtpl->assign("ROW_BG_COLOR", $current_color);
    $color_iterator += 1;

    // For now, we simply put "yes" or "no" into the table. Later on we might
    // include another template with an icon(?)
    reset($rightsList);
    while (list($kind, $dummy) = each($rightsList)) {
        $tokenname = "RIGHT_" . strtoupper($kind);
        //if ($parsed[$permuser][$kind] == 1)
        if (isset($parsed[$permuser][$kind]))
            $permstatus = _("Yes");
        else
            $permstatus = _("No");
        $trtpl->assign($tokenname, $permstatus);
    }

    $tablerows .= $trtpl->easy_print_string();

}

$tabletpl = new EasyTemplate(SM_PATH . 'plugins/imapacl/templates/foldermanage_table.html');

labeltable_apply($tabletpl, 'foldermanage_table');

while (list($rn,$rd) = each($rightsListSmall)) {
    $tabletpl->assign('LABEL_'.strtoupper($rn), $rd);
}

$tabletpl->assign("COLOR_HEADER", $color[3]);
$tabletpl->assign("TABLE_ROWS", $tablerows);

$completetable = "<CENTER>". $tabletpl->easy_print_string() . "</CENTER>\n";

$fm_content = ia_html_box(_("Current permissions of:") . ' ' . $ia_folder2manage, $completetable);


// Build the Add new User-box
$newuser  = _("To add permissions for a new user not listed above, enter the username <i>(NOT the email)</i> below.") . "\n";
$newuser .= "<p />\n";
$newuser .= "<form action=\"editrights.php\" method=\"POST\">";
$newuser .= _("Username:") . "&nbsp;";
$newuser .= "<input type=\"hidden\" name=\"folder2edit\" value=\"$ia_folder2manage\">\n";
$newuser .= "<input type=\"hidden\" name=\"newuser\" value=\"yes\">\n"; // This will save the next page the imap login.
$newuser .= "<input type=\"text\" name=\"user2edit\">\n";
$newuser .= "<p /><center><input type=\"submit\" name=\"submitnewuser\" value=\""._("Add new user")."\"></center></form>\n";

$fm_content .= ia_html_box(_("Add Permission for new User"),$newuser);


$cancel  = "<CENTER><A HREF=\"folderlist.php\">". _("Choose other folder") . "</A></CENTER>\n";

$fm_content .= ia_html_box(_("Manage a different Folder"), $cancel);


ia_html_mainbox(_("IMAP ACL Management"), $fm_content);

// Finished.
sqimap_logout($imapconn);

IA_clean_language();

?>